/**
 * @fileOverview
 * @authors Your Name (you@example.org)
 */
(function (window, document) {
    var port = chrome.extension.connect({name: 'planc'});

    var $ = function (str, parent) {
        parent = parent || document;
        return parent.querySelectorAll(str);
    };

    function getStyle(ele, attr) {
        return ele.currentStyle ? ele.currentStyle[attr] : getComputedStyle(ele, false)[attr];
    }

    function hasClass(ele, cls) {
        if (ele.classList) {
            return ele.classList.contains(cls);
        } else {
            var reg = new RegExp('(^|\\s)' + cls + '($|\\s)', 'i');
            return reg.test(ele.className);
        }
    }

    function template(html, data) {
        if (!html || !data) {return '';}
        return html.replace(/\{\{(\w+)\}\}/g, function (str, key) {
            return data[key] === undefined ? str : data[key];
        });
    }


    function bindEvent() {
        var searchbar = $('#searchbarforipad')[0];
        if (!searchbar) {return;}
        var btn = $('.searchbar-btn', searchbar)[0];
        var close = $('.searchbar-close', searchbar)[0];
        var configBtn = $('.searchbar-config-btn', searchbar)[0];
        var configBox = $('.searchbar-config', searchbar)[0];
        var switchBtn = $('#searchbar-switch-ipad')[0];

        btn.addEventListener('click', function () {
            chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 2}});
        }, false);


        close.addEventListener('click', function () {
            searchbar.style.display = 'none';
            chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 3}});
        }, false);

        configBtn.addEventListener('click', function (e) {
            e.stopPropagation();
            var display = getStyle(configBox, 'display');
            configBox.style.display = display === 'block' ? 'none' : 'block';
            chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 6}});
        });

        switchBtn.addEventListener('click', function (e) {
            e.stopPropagation();
            if (hasClass(switchBtn, 'searchbar-switch-on')) {
                switchBtn.className = '';
                chrome.runtime.sendMessage({cmd: 'switch', type: 'searchBar', value: 0});
                chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 5}});
            } else {
                switchBtn.className = 'searchbar-switch-on';
                chrome.runtime.sendMessage({cmd: 'switch', type: 'searchBar', value: 1});
                chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 4}});
            }
        });

        configBox.addEventListener('click', function (e) {
            e.stopPropagation();
        });

        document.addEventListener('click', function () {
            configBox.style.display = 'none';
        });
    }

    var tpl = '' +
        '<div id="searchbarforipad">' +
            '<div id="searchbar-placeholder-ipad"></div>' +
            '<div id="searchbar-inner-ipad" class="searchbar-inner clearfix">' +            
                '<div class="searchbar-icon"></div>' +
                '<div class="searchbar-title"><span class="name">{{name}}-</span><span class="searchbar-intro">{{desc}}</span></div>' +
                '<div class="official"></div>' +
                '<a href="{{link}}" target="_blank" class="searchbar-btn">去安装</a>' +
                '<div class="searchbar-config">' +
                    '<span id="searchbar-switch-ipad" class=""></span>关闭搜索推荐' +
                '</div>' +
                '<span class="searchbar-config-btn"></span>' +
                '<span class="searchbar-close"></span>' +
            '</div>' +
        '</div>';
    
    var softwareInfo = {
        name : 'QQ浏览器HD',     
        link : 'http://browser.qq.com/ipad/index.html?ADTAG=pc-qqbrowser-search',
        desc : '极速搜索，微信热文，全网视频，无广告小说'
    };    


    function updateView(keyword) {
        var searchbar = $('#searchbarforipad')[0];
        if (searchbar) {
            $('.searchbar-icon', searchbar)[0].src = softwareInfo.iconUrl;
            $('.searchbar-title', searchbar)[0].innerHTML = softwareInfo.name + '-<span class="searchbar-intro">' + softwareInfo.desc + '</span>';
        } else {
            var html = template(tpl, softwareInfo);
            var div = document.createElement('div');
            div.innerHTML = html;
            searchbar = $('#searchbarforipad', div)[0];
            document.documentElement.insertBefore(searchbar, document.body);
            bindEvent();
        };
        searchbar.style.display = 'block';
        chrome.runtime.sendMessage({cmd: 'report', value: {key: 22001, int1: 1, str1: keyword}});   
    }

    chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
        updateView(request);
    });

})(window, document);
